cc          for test of kbetar generator
c          implicit none
c          real*8 a, b, x
c          integer i
c          call cerrorMsg('Enter a, b', 1)
c          read(*, *) a, b
c          do  i=1, 100000
c             call kbetar(a, b, x)
c             write(*, *) sngl(x)
c          enddo
c          end
c- -------------------------- for drawing curve ---------------
c
c          anrm=gamma(a)*gamma(b)/gamma(a+b)
c
c             f=      x**(a-1.)* (1.-x)**(b-1.)/anrm
c       **************************
        subroutine kbetar(a, b, x)
c       **************************
        implicit none
        real*8 a  ! input. see below
        real*8 b  ! input. see below
        real*8 x  ! output. sampled random variable

c           generate a random variable x following beta function kernel
c           i.e.  density function is x**(a-1)* (1-x)**(b-1)dx
c
c          both of a and b cannot be < 1.0
c              if a and b unbalance largely, rejection rate will
c              become large: (a=2, b=5--->1/6.6 is accepted
c                             a=2.1,b=1.2-->30 % rejection)
c        To sample  100000 variables, 4.226 sec is needed.
c       (wiht a=1.5, b=2.5 with facom m780)
c       this is sometimes faster than ksbeta for a class of a,b
c       but has limitations.

        real*8 ai, bm, u, bi, am

        if(a .lt. 1. and. b .lt. 1.) then
           write(*,*) ' kbetar cannot accept a<1,b<1:'
           write(*,*) ' use, ksbeta in such case'
           write(*,*) ' a=',a, ' b=',b
           stop
        endif
        if( (a .ge. b .and. b .ge. 1.)  .or.  a .lt. 1.) then
           ai=1./a

           bm=b-1.
c             *** until loop*** 
           do while (.true.)
              call rndc(u)

              x=u**ai
              call rndc(u)
              if         ( u .le. (1.-x)**bm)
     *             goto 100
           enddo
 100       continue
        else
           bi=1./b
           
           am = a-1.
c            *** until loop*** 
           do while (.true.)
              call rndc(u)
              x=1.-u**bi
              call rndc(u)
              if         ( u .le. x**am)
     *             goto 200
           enddo
 200       continue
        endif
        end
